/// <reference types="node" />
import commandLineArgs from 'command-line-args';
import { Stream } from 'stream';
import { Observable } from 'rxjs';
declare type FileToStream = (file: string) => Stream;
export interface ArgvOptions {
    input: FileToStream;
    output: FileToStream;
    'output-mode': (observable: Observable<any>, fileToStream: FileToStream) => Stream;
    home: string;
    inline: string;
    command: ArgvCommand;
    help: boolean;
}
interface ArgvCommand {
    name: string;
    args: string[];
}
declare const _default: (argv?: any) => Promise<commandLineArgs.CommandLineOptions>;
export default _default;
export declare function usage(): string;
